package com.mx.cneeds.server.datashow.web.device;

import com.google.gson.Gson;
import com.mx.cneeds.common.constant.FilePath;
import com.mx.cneeds.common.converter.RequestParamterConverter;
import com.mx.cneeds.common.dto.*;
import com.mx.cneeds.common.result.R;
import com.mx.cneeds.common.vo.DeviceLogFileVo;
import com.mx.cneeds.common.vo.WechatDeviceLogVo;
import com.mx.cneeds.server.datashow.client.DeviceClient;
import com.mx.cneeds.server.datashow.client.LogFileClient;
import com.mx.hbasefile.hadoop.hdfs.api.HdfsTemplate;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @ClassName LogFileController
 * @Author zzrdark
 * @Date 2020-04-01 15:14
 * @Description TODO
 **/
@Controller
@Slf4j
@RequestMapping("/logFile")
public class LogFlieController {

    @Autowired
    private LogFileClient logFileClient;

    @Autowired
    private DeviceClient deviceClient;

    @Autowired
    private HdfsTemplate hdfsTemplate;

    @PostMapping("/logfile/wechatDeviceLogUpload")
    public R wechatUploadLog(WechatDeviceLogVo vo, MultipartFile[] file){
        WechatDeviceLogDto dto = new WechatDeviceLogDto();
        BeanUtils.copyProperties(vo, dto);

        // 把图片存入oos 返回路径
        // dto.setLogfileUrl()

        DeviceInfoDto deviceInfoDto = deviceClient.queryDeviceByImei(dto.getImei());
        dto.setDeviceId(deviceInfoDto.getDeviceId());
        logFileClient.wechatUploadLog(dto);
        return R.ok();
    }

    @PostMapping("/logfile/DeviceLogFileUpload")
    public R uploadLogFile(DeviceLogFileVo vo, MultipartFile file) throws IOException {
        DeviceLogFileDto dto = new DeviceLogFileDto();
        BeanUtils.copyProperties(vo, dto);

        // 把图片存入oos 返回路径
        // dto.setLogfileUrl()
        StringBuffer dir = new StringBuffer(FilePath.LogFilePath);


        // 1. 读取系统时间
        Calendar calendar = Calendar.getInstance();
        Date time = calendar.getTime();

        // 2. 格式化系统时间
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd-HH-mm-ss");
        String fileName = format.format(time);
        dir.append(fileName);
        hdfsTemplate.saveFile(dir.toString(),file.getName(),file.getInputStream(),file.getSize(), (short) 2);
        DeviceInfoDto deviceInfoDto = deviceClient.queryDeviceByImei(dto.getImei());
        dto.setDeviceId(deviceInfoDto.getDeviceId());
        logFileClient.uploadLogFile(dto);
        return R.ok();
    }
}
